# Auto Request To Logistic Chest Requester 1.0.0
First Mod to Factorio

Type: Mod
Name: Auto Request to Logistic Chest Requester
Description: The Requester Chest, it automatically calls the items that the assembly machine need to build, depending on the chosen multiplier (1-10).
License: [url]https://opensource.org/licenses/MIT[/url]
Version: 1.0.0
Release: 2016-05-26
Tested-With-Factorio-Version: 0.12.33
Category: Helper, SimpleExtension, Gameplay, Convenience, Requester
Tags: Auto, Request, Chest, Logistic
Download-Url: [url]http://Direct-download-Url[/url]
Website: [url]http://some%20project%20page[/url]

# License
The MIT License (MIT)
Copyright (c) 2016 Mauro Junior

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.[/spoiler]

# Description to Use

It has an assembly machine (1, 2 or 3) with a pre-defined revenue and an inserter (either 5) ... When placing the Requestor Chest, automatically this will check on the assembly machine ingredients you need and will request them.

The amount of ingredients that will ask for each recipe, depends on the chosen multiplier configuration.

[img]http://i.imgur.com/3OWprjb.png[/img]

Example:

1 - In the following image we have four assembly machines already with their recipes and inserters in place.

[img]http://i.imgur.com/plk7CN7.png[/img]

2 - By placing the Requestor Chest, it will check the ingredients that need recipe, multiplied by the multiplier.

[*] a) -> Small Electric Pole = 2 wood + 2 Copper Cable
[*] b) -> Multiplier = 2
[*] c )-> Ingredients that will be requested: 4 wood + 4 Cooper Cable

[img]http://i.imgur.com/F1fsj5S.png[/img]

To turn off, just click the green color button. Turn on in red.

[img]http://i.imgur.com/94dk6q9.png[/img]

[img]http://i.imgur.com/yDQYwWm.png[/img][/spoiler]

# Importants Notes

a) The ingredients requisition order follows the order below: (works according to the function "entities" API 12:33)

[img]http://i.imgur.com/T2yGVuY.png[/img]

b) If the same ingredients in different recipes, is inserted just a single pile of requisition items.

c) The Requestor Chest stores only 10 different items, so if the total ingredients is greater than 10, no ingredient of that recipe will be requested.

Example: (all ingredients are distinct from each other)

Recipe 1 = 3 ingredients
Recipe 2 = 4 ingredients
Recipe 3 = 2 ingredients
Recipe 4 = 3 ingredients 

Following the API analytical order, the requestor will get chest:

Requested ingredient in the compartment 1-3 = Recipe 1
Requested ingredient in the compartment 4-7 = Recipe
Requested ingredient in the compartment 7-9 = Recipe 3
Requested ingredient in the compartment 10 = Empty

that is, the ingredients of Recipe 4 will not be asked, because beyond the limit of 10 items.[/spoiler]

# Future Version
I'm better study the API to find out the method that is called when changing the Recipe in Assembly machine, allowing update items in Requestor Chest.[/spoiler]

# Version history
Version# (2015-5-26): 1.0.0 - Initial Released[/spoiler]
